package org.jboss.security.plugins;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import javax.naming.InvalidNameException;
import javax.naming.NamingException;
import javax.security.auth.Subject;
import org.jboss.security.AuthenticationManager;
import org.jboss.security.RealmMapping;
import org.jboss.security.SubjectSecurityManager;
import org.jboss.util.CachePolicy;

public class SecurityDomainContext {
  static final String ACTIVE_SUBJECT = "subject";
  
  static final String AUTHENTICATION_MGR = "securityMgr";
  
  static final String AUTORIZATION_MGR = "realmMapping";
  
  static final String AUTH_CACHE = "authenticationCache";
  
  AuthenticationManager securityMgr;
  
  CachePolicy authenticationCache;
  
  public SecurityDomainContext(AuthenticationManager securityMgr, CachePolicy authenticationCache) {
    this.securityMgr = securityMgr;
    this.authenticationCache = authenticationCache;
  }
  
  public Object lookup(String name) throws NamingException {
    Object binding = null;
    if (name == null || name.length() == 0)
      throw new InvalidNameException("name cannot be null or empty"); 
    if (name.equals("subject")) {
      binding = getSubject();
    } else if (name.equals("securityMgr")) {
      binding = this.securityMgr;
    } else if (name.equals("realmMapping")) {
      binding = getRealmMapping();
    } else if (name.equals("authenticationCache")) {
      binding = this.authenticationCache;
    } 
    return binding;
  }
  
  public Subject getSubject() {
    Subject subject = null;
    if (this.securityMgr instanceof SubjectSecurityManager)
      subject = ((SubjectSecurityManager)this.securityMgr).getActiveSubject(); 
    return subject;
  }
  
  public AuthenticationManager getSecurityManager() {
    return this.securityMgr;
  }
  
  public RealmMapping getRealmMapping() {
    RealmMapping realmMapping = null;
    if (this.securityMgr instanceof RealmMapping)
      realmMapping = (RealmMapping)this.securityMgr; 
    return realmMapping;
  }
  
  public CachePolicy getAuthenticationCache() {
    return this.authenticationCache;
  }
}
